#include <iostream>
#include<vector>
using namespace std;

int main()
{
  int n,x,y,p,zbir=0,nz=-1,najveciz=0,zamena=0,zbir2,najvecazamena;
  long long mx=100001,my=100001,l=1000000007;
  cin>>n;
  vector<int>tx;
  vector<int>ty;
  vector<int>najmanjix;
  vector<int>najmanjiy;
 
  for(int i=0;i<n;i++)
    {
      cin>>x>>y;
      tx.push_back(x);
      ty.push_back(y);
      if(mx>x)
      {najmanjix.push_back(x);
        mx=x;}
      else
        najmanjix.push_back(mx);
      if(my>y)
      {najmanjiy.push_back(y);
        my=y;}
      else
        najmanjiy.push_back(my);
    }
  for(int i=0;i<n;i++)
  {
      
      zbir=0;
      if(i==0)
        zbir=0;
      else
     {
        for(int t=0;t<i+1;t++)//tacka koju smo pogodili
          {
            zamena=0;
            zbir2=0;
            for(int g=0;g<i+1;g++)
                 zbir2+=abs(tx.at(g)-tx.at(t))*abs(ty.at(g)-ty.at(t));
            
              
          if(zbir2>zamena)
            zamena=zbir2;
            
          zbir+=abs(tx.at(t)-najmanjix.at(i))*abs(ty.at(t)-najmanjiy.at(i));
          }
       }
      
        
        
      if(zamena>zbir)
        cout<<"najveci";
      cout<<max(zamena,zbir)%l<<endl;
      cout<<zamena<<"zamena"<<endl;
       }
   
    return 0;
}